<?php

//iPay88 PAYMENT MODULE FOR PRESTASHOP

if (!defined('_PS_VERSION_'))
exit;

class ipay88_all extends PaymentModule
{
	private $_html 			= '';
	private $_postErrors 	= array();

	public  $details;
	public  $owner;
	public  $address;
	public  $extra_mail_vars;
	
	//this is variable for vs_configuration 
	public 	$method_title;
	public  $description;
	public  $merchant_code;
	public  $merchant_key;
	
	//options
	public  $payment_types	= "";
	public  $action_ipay88 	= "";	
	
		
	public function __construct()
	{
		$this->name 			= 'ipay88_all';
		$this->tab 				= 'payments_gateways';
		$this->version 			= '1.0.1';
		$this->author 			= 'iPay88 - System Engineer Officer';
		$this->controllers 		= array('payment', 'validation');
		$this->currencies 		= true;
		$this->currencies_mode 	= 'checkbox';
		
	
		$config = Configuration::getMultiple(array('method_title','description','merchant_code','merchant_key','action_ipay88'));
		
		if (isset($config['method_title']))
			$this->method_title = $config['method_title'];
		
		if (isset($config['description']))
			$this->description = $config['description'];
			
		if (isset($config['merchant_code']))
			$this->merchant_code = $config['merchant_code'];
			
		if (isset($config['merchant_key']))
			$this->merchant_key = $config['merchant_key'];
			
		if (isset($config['action_ipay88']))
			$this->action_ipay88 = $config['action_ipay88'];
			
				
		$this->bootstrap = true;
		parent::__construct();
		
		$this->displayName 			= $this->l('iPay88 Payment Gateway');
		$this->description 			= $this->l('Allows you to use iPay88 Payment Gateway with the Prestashop module.');
		$this->confirmUninstall 	= $this->l('Are you sure about removing these details?');
		
		$this->ps_versions_compliancy 	= array('min' => '1.6.0.1', 'max' => _PS_VERSION_);
				
		if (!isset($this->owner) || !isset($this->details) || !isset($this->address))
			$this->warning = $this->l('Account owner and account details must be configured before using this module.');
		
		if (!count(Currency::checkPaymentCurrencies($this->id)))
			$this->warning = $this->l('No currency has been set for this module.');	
	}

		
	//PARAMETER FOR INSTALL
	public function install()
    {
        if (!parent::install() || !$this->registerHook('payment') || !$this->registerHook('displayPaymentEU') || !$this->registerHook('paymentReturn') || !$this->registerHook('header')) 
		{
            return false;
        }				
						
		$validation_value 	= array (
										'method_title'		=> '',
										'description'		=> '',
										'merchant_code'		=> '',
										'merchant_key'	 	=> '',
										'payment_types'		=> '',
										'action_ipay88'	 	=> '',
									);
		
		
		$order 				= array (
										0	=> 'Payment Pending',
										1	=> 'Payment Success',
										2	=> 'Payment Failed',
									);
	
	
		$template_mail 		= array (
										0	=> 'ipay88_pending',
										1   => 'ipay88_success',
										2	=> 'ipay88_failed',	 
									);


		$color 				= array (
										0	=> '#FF8C00',
										1	=> 'LimeGreen',
										2	=> 'Crimson',
									);
					
		
		$config 			= array (
										0		=> 'ipay88_pending',
										1		=> 'ipay88_success',
										2		=> 'ipay88_failed',
									);
		
		
		for($i=0;$i<3;$i++)
		{
			if(!Configuration::get($config[$i]))
			{
				$orderState 			= new OrderState();	
				$orderState->name 		= array();
				$orderState->template	= array();
				
				foreach (Language::getLanguages() AS $language)
				{
					$orderState->name[$language['id_lang']] = $order[$i];
				}
				
				$orderState->send_email = false;
				$orderState->invoice 	= true;
				$orderState->hidden 	= false;
				$orderState->delivery	= false;
				$orderState->logable 	= false;
				$orderState->template	= $template_mail[$i];
				$orderState->color 		= $color[$i];
				
				$orderState->add();
			}
			
			Configuration::updateValue($config[$i], (int)($orderState->id));
		}
		
		
		//added configuration validation value
		Configuration::updateValue('method_title', 'iPay88 Payment Gateway');
		Configuration::updateValue('description', 'Please note that your Payment is processed by iPay88 Payment Gateway. The page will redirect to iPay88 payment page when you press Confirm Order button.');
		Configuration::updateValue('merchant_code',	$validation_value['merchant_code']);
		Configuration::updateValue('merchant_key',	$validation_value['merchant_key']);
		Configuration::updateValue('action_ipay88',	$validation_value['action_ipay88']);
			
		return true;
	}


	//DISPLAY IPAY88 CONFIGIRATION SETTING. CALL PRIVATE METHOD
	public function getContent()
	{
		if (Tools::isSubmit('btnSubmit'))
		{
			$this->_postValidation();
			
			if (!count($this->_postErrors))
				$this->_postProcess();
			
			else
				foreach ($this->_postErrors as $err)
				$this->_html .= $this->displayError($err);
		}
		
		else
		
		$this->_html .= '<br />';
		$this->_html .= $this->_displayipay88_all();
		$this->_html .= $this->renderForm();

		return $this->_html;
	}


	//ADMIN -- CONFIGURATION VIEW
	private function _displayipay88_all()
	{
		return $this->display(__FILE__, 'infos.tpl');
	}


	//ADMIN -- CONFIGURATION FORM
	public function renderForm()
	{
		//OPTION
		$payment_types = array(
								
					  array(
								'id_option' => '1',                 
								'name' 		=> 'Credit Card',	
							),
					  array(
								'id_option' => '4',
								'name' 		=> 'Mandiri ClickPay',
							),
					  array(
								'id_option' => '11',
								'name' 		=> 'CIMB Clicks',
							),
			 		  array(
								'id_option' => '14',
								'name' 		=> 'Internet Banking Muamalat',
							),
					  array(
								'id_option' => '23',
								'name' 		=> 'Danamon Online Banking',
							),
					  array(
								'id_option' => '9',
								'name' 		=> 'Maybank VA',
							),
					  array(
								'id_option' => '17',
								'name' 		=> 'Mandiri ATM Automatic',
							),
					  array(
								'id_option' => '25',
								'name' 		=> 'BCA VA',
							),
					  array(
								'id_option' => '31',
								'name' 		=> 'Permata VA',
							),
					  array(
								'id_option' => '7',
								'name' 		=> 'XL Tunai',
							),
					  array(
								'id_option' => '13',
								'name' 		=> 'Mandiri e-cash',
							),
					  array(
								'id_option' => '15',
								'name' 		=> 'TCASH',
							),
					  array(
								'id_option' => '16',
								'name' 		=> 'PayPro',
							),
					  array(
								'id_option' => '19',
								'name' 		=> 'Pay By QR',
							),
					  array(
								'id_option' => '22',
								'name' 		=> 'Pay4Me',
							),
		);
			
		$action_ipay88 = array(
					
					  array(
								'id_option' => 'https://sandbox.ipay88.co.id/epayment/entry.asp',
								'name' 		=> 'Sandbox',
							),	
								
					  array(
								'id_option' => 'https://payment.ipay88.co.id/epayment/entry.asp',
								'name' 		=> 'Production',	
							),					
		);
		
	
		
		//CONFIGURATION FORM
		$fields_form = array(
							
			'form'	 => array(
							
			'legend' => array(
								'title' => $this->l('iPay88 Payment Gateway Configuration'),
								'icon' => 'icon-cogs'
							),
				
							
			'input' => 	array(	
																				
						array(
						'type'  => 'text',
						'label' => '<span style="color:red"><b>*</b></span> '.$this->l('Method Title'),
						'name'  => 'method_title',
						'hint'  => array(
									$this->l('This controls the title which the user sees during checkout.')
									),
						 ),
											 
						array(
						'type'  => 'textarea',
						'label' => '<span style="color:red"><b>*</b></span> '.$this->l('Description'),
						'name'  => 'description',
						'hint'  => array(
									$this->l('This controls the description which the user sees during checkout.')
									),
						),
											 
						array(
						'type'  => 'text',
						'label' => '<span style="color:red"><b>*</b></span> '.$this->l('Merchant Code'),
						'name'  => 'merchant_code',
						'hint'  => array(
									$this->l('The Merchant Code provided by iPay88 and used to uniquely identify the merchant.'),						
									),
							),
											 
						array(
						'type'  => 'text',
						'label' => '<span style="color:red"><b>*</b></span> '.$this->l('Merchant Key'),
						'name'  => 'merchant_key',
						'hint'  => array(
								  	$this->l('Provided by iPay88 and shared between iPay88 and merchant only.')
									),
							),
					
						array(
						'type' 		=> 'checkbox',
						'label' 	=> $this->l('Payment Types'),
						'name' 		=> 'payment_types',
						'class' 	=> 'iPay88',
						'multiple' 	=> true,
												
						'hint' 		=> array(
										$this->l('Choose the payment types you can offer to the customers. The Payment types will be presented to the customer to pre-select on the checkout page.')
								   ),
						
						'values' 	=> array(
												'query'  => $payment_types,
												'id' 	 => 'id_option',
												'name' 	 => 'name',
									   		)			
								),	
											 
						array(
						'type' 		=> 'select',
						'label' 	=> $this->l('Action to iPay88'),
						'name' 		=> 'action_ipay88',
						'required' 	=> false,
						'hint'  	=> array(
										$this->l('Sandbox mode provides you with a chance to test your gateway integration with iPay88. The payment requests will be send to the iPay88 sandbox URL.
Production to start accepting live payment.')
										),
						'options' 	=> array(
												'query' => $action_ipay88,
												'id' 	=> 'id_option',
												'name' 	=> 'name'
						 					)
								),
							),
				
					'submit' => array(
					'title' => $this->l('Save'),
				)
			),
		);
		
		
		$helper 				= new HelperForm();
		$helper->show_toolbar 	= false;
		
		$helper->table 			= $this->table;
		$lang 					= new Language((int)Configuration::get('PS_LANG_DEFAULT'));

		
		$helper->default_form_language 		= $lang->id;
				
		$helper->allow_employee_form_lang 	= Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
		
		
		$this->fields_form 		= array();
		$helper->id 			= (int)Tools::getValue('id_carrier');
		$helper->identifier 	= $this->identifier;
		$helper->submit_action 	= 'btnSubmit';
		
		
		$helper->currentIndex 	= $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;
		
		
		$helper->token 		= Tools::getAdminTokenLite('AdminModules');
		$helper->tpl_vars 	= array(
										'fields_value' 	=> $this->getConfigFieldsValues(),
										'languages' 	=> $this->context->controller->getLanguages(),
										'id_language' 	=> $this->context->language->id
									);

		return $helper->generateForm(array($fields_form));
	}
	
	
	//ADMIN -- VALIDATION REQUIRED FORM
	private function _postValidation()
	{
		if (Tools::isSubmit('btnSubmit'))
		{
			if (empty($_POST['method_title']))
				$this->_postErrors[] = $this->l('Method Title is required.');
				
			elseif (empty($_POST['description']))
				$this->_postErrors[] = $this->l('Description is required');
				
			elseif (empty($_POST['merchant_code']))
				$this->_postErrors[] = $this->l('Merchant Code is required');
				
			elseif (empty($_POST['merchant_key']))
				$this->_postErrors[] = $this->l('Merchant Key is required');		
		}
	}
	

	//ADMIN -- GET DATA FROM CONFIGURATION FORM
	public function getConfigFieldsValues()
	{
		return array(
					'method_title'		=> Tools::getValue('method_title',		Configuration::get('method_title')),
					'description' 		=> Tools::getValue('description', 		Configuration::get('description')),
					'merchant_code'		=> Tools::getValue('merchant_code', 	Configuration::get('merchant_code')),	
					'merchant_key'	 	=> Tools::getValue('merchant_key', 		Configuration::get('merchant_key')),	
						
					'payment_types_1'	=> Tools::getValue('payment_types_1', 	Configuration::get('payment_types_1')),	
					'payment_types_4'	=> Tools::getValue('payment_types_4', 	Configuration::get('payment_types_4')),	
					'payment_types_11'	=> Tools::getValue('payment_types_11', 	Configuration::get('payment_types_11')),	
					'payment_types_14'	=> Tools::getValue('payment_types_14', 	Configuration::get('payment_types_14')),
					'payment_types_23'	=> Tools::getValue('payment_types_23',	Configuration::get('payment_types_23')),
					
					'payment_types_9'	=> Tools::getValue('payment_types_9', 	Configuration::get('payment_types_9')),
					'payment_types_17'	=> Tools::getValue('payment_types_17', 	Configuration::get('payment_types_17')),
					'payment_types_25'	=> Tools::getValue('payment_types_25', 	Configuration::get('payment_types_25')),
				    'payment_types_31'	=> Tools::getValue('payment_types_31', 	Configuration::get('payment_types_31')),
					'payment_types_7'	=> Tools::getValue('payment_types_7', 	Configuration::get('payment_types_7')),
					
					'payment_types_13'	=> Tools::getValue('payment_types_13',	Configuration::get('payment_types_13')),
					'payment_types_15'	=> Tools::getValue('payment_types_15',	Configuration::get('payment_types_15')),
					'payment_types_16'	=> Tools::getValue('payment_types_16', 	Configuration::get('payment_types_16')),
					'payment_types_19'	=> Tools::getValue('payment_types_19', 	Configuration::get('payment_types_19')),
					'payment_types_22'	=> Tools::getValue('payment_types_22', 	Configuration::get('payment_types_22')),
														
					'action_ipay88'		=> Tools::getValue('action_ipay88', 	Configuration::get('action_ipay88')),	
					);
	}
	
	
	//POST FORM CONFIGURATION
	private function _postProcess()
	{
		if (Tools::isSubmit('btnSubmit'))
		{
			//print_r($_POST);exit();
			Configuration::updateValue('method_title', 		$_POST['method_title']);
			Configuration::updateValue('description', 		$_POST['description']);
			Configuration::updateValue('merchant_code', 	$_POST['merchant_code']);
			Configuration::updateValue('merchant_key', 		$_POST['merchant_key']);
		
			Configuration::updateValue('payment_types_1', 	$_POST['payment_types_1']);
			Configuration::updateValue('payment_types_4', 	$_POST['payment_types_4']);
			Configuration::updateValue('payment_types_11', 	$_POST['payment_types_11']);
			Configuration::updateValue('payment_types_14', 	$_POST['payment_types_14']);
			Configuration::updateValue('payment_types_23', 	$_POST['payment_types_23']);
			
			Configuration::updateValue('payment_types_9', 	$_POST['payment_types_9']);
			Configuration::updateValue('payment_types_17', 	$_POST['payment_types_17']);
			Configuration::updateValue('payment_types_25', 	$_POST['payment_types_25']);
			Configuration::updateValue('payment_types_31', 	$_POST['payment_types_31']);
			Configuration::updateValue('payment_types_7', 	$_POST['payment_types_7']);
			
			Configuration::updateValue('payment_types_13', 	$_POST['payment_types_13']);
			Configuration::updateValue('payment_types_15', 	$_POST['payment_types_15']);
			Configuration::updateValue('payment_types_16', 	$_POST['payment_types_16']);
			Configuration::updateValue('payment_types_19', 	$_POST['payment_types_19']);
			Configuration::updateValue('payment_types_22', 	$_POST['payment_types_22']);
						
			Configuration::updateValue('action_ipay88', $_POST['action_ipay88']);
			
			$_POST['MY_MODULE_CUSTOMERS'] = implode(',', Tools::getValue('MY_MODULE_CUSTOMERS'));
		}
		
		$this->_html .= $this->displayConfirmation($this->l('Settings updated'));
	}


	//UNINSTALL
	public function uninstall()
	{	
		if (!Configuration::deleteByName('method_title')
		|| !Configuration::deleteByName('description')
	 	|| !Configuration::deleteByName('merchant_code')
		|| !Configuration::deleteByName('merchant_key')
		
		//PAYMENT TYPES 
		|| !Configuration::deleteByName('payment_types')
		
		|| !Configuration::deleteByName('payment_types_1')
		|| !Configuration::deleteByName('payment_types_4')
		|| !Configuration::deleteByName('payment_types_11')
		|| !Configuration::deleteByName('payment_types_14')
		|| !Configuration::deleteByName('payment_types_23')
		
		|| !Configuration::deleteByName('payment_types_9')
		|| !Configuration::deleteByName('payment_types_17')
		|| !Configuration::deleteByName('payment_types_25')
		|| !Configuration::deleteByName('payment_types_31')
		|| !Configuration::deleteByName('payment_types_7')
		
		|| !Configuration::deleteByName('payment_types_13')
		|| !Configuration::deleteByName('payment_types_15')
		|| !Configuration::deleteByName('payment_types_16')
		|| !Configuration::deleteByName('payment_types_19')
		|| !Configuration::deleteByName('payment_types_22')
				
		|| !Configuration::deleteByName('action_ipay88')
		|| !parent::uninstall())
		
	
        return false;
    	
		else
        
		return true;
	}
	
	
	//PASSING PARAMETER TO CUSTOMER CHECKOUT PAYMENT
	public function hookPayment($params)
    {
        if (!$this->active) 
		{
       		return;
        }
        
		if (!$this->checkCurrency($params['cart'])) 
		{
            return;
        }
				
		$view_method_title	  	= Configuration::get('method_title');
        $view_description     	= Configuration::get('description');
		
		$view_payment_types   	= Configuration::get('payment_types');
		
		$view_payment_types_1 	= Configuration::get('payment_types_1');
		$view_payment_types_4  	= Configuration::get('payment_types_4');
		$view_payment_types_11  = Configuration::get('payment_types_11');
		$view_payment_types_14  = Configuration::get('payment_types_14');
		$view_payment_types_23  = Configuration::get('payment_types_23');		
		
		$view_payment_types_9	= Configuration::get('payment_types_9');
		$view_payment_types_17  = Configuration::get('payment_types_17');
		$view_payment_types_25  = Configuration::get('payment_types_25');
		$view_payment_types_31  = Configuration::get('payment_types_31');
		$view_payment_types_7  	= Configuration::get('payment_types_7');
		
		$view_payment_types_13	= Configuration::get('payment_types_13');
		$view_payment_types_15  = Configuration::get('payment_types_15');
		$view_payment_types_16  = Configuration::get('payment_types_16');
		$view_payment_types_19  = Configuration::get('payment_types_19');
		$view_payment_types_22 	= Configuration::get('payment_types_22');
				
		$this->smarty->assign(array(
            'this_path'			=> $this->_path,
            'this_path_bw' 		=> $this->_path,
            'this_path_ssl' 	=> Tools::getShopDomainSsl(true, true).__PS_BASE_URI__.'modules/'.$this->name.'/',
			
			'method_title' 		=> $view_method_title,
			'description' 		=> $view_description,
		
			'payment_types_1' 	=> $view_payment_types_1, 	
			'payment_types_4' 	=> $view_payment_types_4, 	
			'payment_types_11' 	=> $view_payment_types_11, 
			'payment_types_14' 	=> $view_payment_types_14,
			'payment_types_23' 	=> $view_payment_types_23,  
		
			'payment_types_9' 	=> $view_payment_types_9,	
			'payment_types_17' 	=> $view_payment_types_17,  
			'payment_types_25' 	=> $view_payment_types_25, 
			'payment_types_31' 	=> $view_payment_types_31, 
			'payment_types_7' 	=> $view_payment_types_7,  	
		
			'payment_types_13' 	=> $view_payment_types_13,	
			'payment_types_15' 	=> $view_payment_types_15,  
			'payment_types_16' 	=> $view_payment_types_16, 
			'payment_types_19' 	=> $view_payment_types_19, 
			'payment_types_22' 	=> $view_payment_types_22, 	
	
		));
		
        return $this->display(__FILE__, 'payment.tpl');

    }


    public function hookDisplayPaymentEU($params)
    {
        if (!$this->active) 
		{
            return;
        }

        if (!$this->checkCurrency($params['cart'])) 
		{
            return;
        }

        $payment_options = array(
            'cta_text' 	=> $this->l('Pay with iPay88 Payment Gateway'),
            'logo' 		=> Media::getMediaPath(dirname(__FILE__).'/logo.jpg'),
            'action' 	=> $this->context->link->getModuleLink($this->name, 'validation', array(), true)
        );

        return $payment_options;
    }
	
	
	//AFTER REVIEW || STEP 6
	public function hookPaymentReturn($params)
	{
		if (!$this->active)
			return;

		$state = $params['objOrder']->getCurrentState();
		if ($state == Configuration::get('ipay88_pending') || $state == Configuration::get('PS_OS_PAYMENT'))
		{
			$this->smarty->assign(array(
				'status' 			=> '1',
				'id_order' 			=> $params['objOrder']->id
			));
			
			if (isset($params['objOrder']->reference) && !empty($params['objOrder']->reference))
				$this->smarty->assign('reference', $params['objOrder']->reference);
		}
				
		else if ($state == Configuration::get('PS_OS_ERROR')) 
		{
        	$this->smarty->assign(array(
            	'status' => '0',
                'id_order' => $params['objOrder']->id
            ));
			
            if (isset($params['objOrder']->reference) && !empty($params['objOrder']->reference))
                $this->smarty->assign('reference', $params['objOrder']->reference);
        }
        
		else
		{
			$this->smarty->assign('status', 'other');
		}
			
		return $this->display(__FILE__, 'payment_return.tpl');
	}	
	
	
	//CURRENCY
	public function checkCurrency($cart)
	{
		$currency_order 	= new Currency($cart->id_currency);
		$currencies_module 	= $this->getCurrency($cart->id_currency);

		if (is_array($currencies_module))
			foreach ($currencies_module as $currency_module)
			
			if ($currency_order->id == $currency_module['id_currency'])
				 return true;
		
		return false;
	}
	
		
	//CSS
	public function hookHeader()
    {
		$this->context->controller->addCSS($this->_path.'assets/css/ipay88.css', 'all');
    }
	
}
